/**
 * 
 * Copyright (c) 2021, Catalina Sbert (main author), catalina.sbert@uib.es
 *                     Jose-Luis Lisani (minor changes), joseluis.lisani@uib.es
 * All rights reserved.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _KERNELS_H_
#define _KERNELS_H_


double *apply_kernel(double *input, double *kernel,
                     int width, int height, int nchannels);
                  
double *apply_kernel_AG(double *input, double *scale, int nscales, double w,
                        int width, int height, int nchannels);

double *F_IG(double sigma1, double sigma2, int width, int  height);
              
double *F_IE(double sigma1, double sigma2, int width, int height);

double *F_1_2(double p, double sigma, int width, int height);

                          
#endif  







    

