/**
 * 
 * Copyright (c) 2021, Catalina Sbert (main author), catalina.sbert@uib.es
 *                     Jose-Luis Lisani (minor changes), joseluis.lisani@uib.es
 * All rights reserved.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

//Compute Min and Max range values (Algorithm 1 in accompanying IPOL paper)
void compute_min_max(double &min, double &max, 
                     double *dataR, double *dataG, double *dataB, 
                     int size, float s1, float s2);
                     
void compute_min_max(double &min, double &max, 
                     double *data, 
                     int size, float s1, float s2);
                     

//Implemented scaling functions (refer to Table 3 in accompanying IPOL paper)

//f_E (Histogram based)
void f_E(double *output, double *input, double p, 
         int size, double Min, double Max);

//f_alpha (Power)
void f_alpha(double *output, double *input, double alpha, 
             int size, double Min, double Max);

//f_log (Logarithm)
void f_log(double *output, double *input, 
           int size, double Min, double Max);

//f_NR (Naka-Rushton)
void f_NR(double *output, double *input, double A, 
          int size, double Min, double Max);

//f_L (Linear)
void f_L(double *output, double *input, 
         int size, double Min, double Max);

double estimate_parameter_alpha(double *input, int size, int nchannels,
                             double Min, double Max);
                             
double estimate_parameter_NR(double *input, int size, int nchannels,
                             double Min, double Max);
                             
                             
                             

